;#############################################################################
;############# The Java class file Viewer                        #############
;#############          by twit <twit.prj@gmail.com>             #############
;#############################################################################

format PE GUI 4.0
entry start

include '%fasminc%\win32ax.inc'

include 'const.inc'
include 'macrstruct.inc'
include 'data.asm'

section '.code' code data readable executable
start:
      xor     ebx,ebx
      invoke  GetModuleHandle,ebx
      mov     [hInst],eax
      mov     [OFN.hInstance],eax
      invoke  InitCommonControls
      invoke  DialogBoxParam,eax,IDD_MAINDLG,0,DialogProc,0
      invoke  ExitProcess,eax

proc DialogProc hwnd,wmsg,wparam,lparam

       mov   eax,[wmsg]
       cmps  WM_COMMAND,.wmcommand
       cmps  WM_CLOSE,.close
       cmps  WM_INITDIALOG,.wminitdialog
       xor   eax,eax
       ret

.wminitdialog:
       mov eax,[hwnd]

       mov [OFN.hwndOwner],eax
       mov [hMainDlg],eax

       invoke GetDlgItem,eax,IDC_BC
       mov [hBC],eax
       mov ebx,[hwnd]
       mov esi,IDC_POOL1
       mov edi,hPool1
       invoke GetDlgItem,ebx,esi
       mov [edi],eax
       mov [CurrentShow],eax
       inc esi
       invoke GetDlgItem,ebx,esi
       mov [edi+4],eax
       inc esi
       invoke GetDlgItem,ebx,esi
       mov [edi+8],eax
       inc esi
       invoke GetDlgItem,ebx,esi
       mov [edi+12],eax
       inc esi
       invoke GetDlgItem,ebx,esi
       mov [edi+16],eax
       inc esi
       invoke GetDlgItem,ebx,esi
       mov [edi+20],eax

       invoke SendDlgItemMessage,ebx,IDC_HDR,BM_SETCHECK,BST_CHECKED,0

       mov edi,LVS_EX_FULLROWSELECT+LVS_EX_FLATSB+00010000h+LVS_EX_GRIDLINES
       mov esi,LVM_SETEXTENDEDLISTVIEWSTYLE
       xor ebx,ebx
       invoke SendMessage,[hPool1],esi,ebx,edi
       invoke SendMessage,[hPool2],esi,ebx,edi
       invoke SendMessage,[hPool3],esi,ebx,edi
       invoke SendMessage,[hPool4],esi,ebx,edi
       invoke SendMessage,[hPool5],esi,ebx,edi
       invoke SendMessage,[hPool6],esi,ebx,edi
       invoke SendMessage,[hBC]   ,esi,ebx,edi
       ;ebx=0 !!!!!!!!!
       ; 
       stdcall pAddColumn,[hPool1],clValue,140
       stdcall pAddColumn,[hPool1],clName,140

       stdcall pAddColumn,[hPool2],clData,157
       stdcall pAddColumn,[hPool2],clConst,155
       stdcall pAddColumn,[hPool2],clType,70
       stdcall pAddColumn,[hPool2],clNumb,38

       stdcall pAddColumn,[hPool3],CPINTERFACE,240
       stdcall pAddColumn,[hPool3],clNumb,35

       stdcall pAddColumn,[hPool4],clAttrN,50
       stdcall pAddColumn,[hPool4],clAccFlg,53
       stdcall pAddColumn,[hPool4],clDescrN,50
       stdcall pAddColumn,[hPool4],clNameN,50
       stdcall pAddColumn,[hPool4],clName,160
       stdcall pAddColumn,[hPool4],clNumb,35

       stdcall pAddColumn,[hPool5],clAttrN,50
       stdcall pAddColumn,[hPool5],clAccFlg,53
       stdcall pAddColumn,[hPool5],clDescrN,50
       stdcall pAddColumn,[hPool5],clNameN,50
       stdcall pAddColumn,[hPool5],clMethods,160
       stdcall pAddColumn,[hPool5],clNumb,35

       stdcall pAddColumn,[hPool6],clData,180
       stdcall pAddColumn,[hPool6],clattrLen,70
       stdcall pAddColumn,[hPool6],clAttrName,100
       stdcall pAddColumn,[hPool6],clNumb,35



       stdcall pAddColumn,[hBC]   ,clAssembl,280
       stdcall pAddColumn,[hBC]   ,clData,130
       stdcall pAddColumn,[hBC]   ,clNumb,35
       xor eax,eax
       ret


.wmcommand:
	mov eax,[wparam]
	cmps IDC_GOPEN,.openclassfile
	cmps IDM_FOPEN,.openclassfile
	cmps IDC_HDR,.showheader
	cmps IDC_HCONST,.showconst
	cmps IDC_HI,.showiterfaces
	cmps IDC_HF,.showfields
	cmps IDC_HA,.showattributes
	cmps IDC_HM,.showmethods

	cmps IDC_GSAVE,.saveclassfile
	cmps IDC_GCLOSE,.close
       mov eax,1
       ret
.close:
       invoke EndDialog,[hwnd],0
       ret
.showheader:
       stdcall pSwapPools,[hPool1]
       ret
.showconst:
       stdcall pSwapPools,[hPool2]
       ret
.showiterfaces:
       stdcall pSwapPools,[hPool3]
       ret
.showfields:
       stdcall pSwapPools,[hPool4]
       ret
.showmethods:
       stdcall pSwapPools,[hPool5]
       ret
.showattributes:
       stdcall pSwapPools,[hPool6]
       ret


.saveclassfile:
       invoke  GetSaveFileName,OFN
       ret

.openclassfile:
       invoke  GetOpenFileName,OFN
       test eax,eax
       jnz @F
       ret
@@:
       xor edx,edx
       invoke SendMessage,[hPool1],LVM_DELETEALLITEMS,edx,edx
       invoke SendMessage,[hPool2],LVM_DELETEALLITEMS,edx,edx
       invoke SendMessage,[hPool3],LVM_DELETEALLITEMS,edx,edx
       invoke SendMessage,[hPool4],LVM_DELETEALLITEMS,edx,edx
       invoke SendMessage,[hPool5],LVM_DELETEALLITEMS,edx,edx
       invoke SendMessage,[hPool6],LVM_DELETEALLITEMS,edx,edx
       invoke SendMessage,[hBC]   ,LVM_DELETEALLITEMS,edx,edx

       call    fCreateMapsOfFiles
       stdcall pVirtualInit,hArray
       stdcall pVirtualAlloc,[hArray],1024*1024*1024
       mov     [hCurrArray],eax

	invoke CreateThread,0,0,DECOMPILE,ThreadParam,0,ThreadID
	mov [hThread],eax

     ;  call    DECOMPILE
     ;  stdcall pVirtualFree,[hArray]
     ;  call    pDestroyMapsOfFiles

  ;     stdcall jDisassemble,tstbuff,tstbuff2
       ret
endp

include 'decompile.asm'
include 'funcs.asm'
include 'rsrc.asm'
include 'import.asm'

