;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                CLASS        ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc DECOMPILE,lParam
;DECOMPILE:


	call READ_HEADER
	call READ_CONSTANTS
	call READ_ACCFLGS
	call READ_THISFLAGS
	call READ_SUPERCLASS
	call READ_INTERFACES_COUNT
	call READ_INTERFACES
	call READ_FIELDS_COUNT
	call READ_FIELDS
	call READ_METHODS_COUNT
	call READ_METHODS
	call READ_ATTRIBUTES_COUNT
	call READ_ATTRIBUTES

	stdcall pVirtualFree,[hArray]
	call	pDestroyMapsOfFiles
	invoke CloseHandle,[hThread]
	ret

	endp


hdr_rva=0
READ_HEADER:
	mov esi,[f.fsData]
	rdu 4
	mov [CAFEBABE],eax
	stdcall pAddItem,[hPool1],roMagic,0,0
	stdcall pAddElement,[hPool1],[CAFEBABE],filt1b,hdr_rva,1
	rdu 4
	mov [VERSION],eax
	stdcall pAddItem,[hPool1],roVersion,1,0
	stdcall pAddElement,[hPool1],[VERSION],filt1b,hdr_rva+1,1
	ret
READ_CONSTANTS:
	rdu 2
	mov [CONTSTANSCOUNT],eax
	stdcall pAddItem,[hPool1],roConstCount,2,0
	stdcall pAddElement,[hPool1],[CONTSTANSCOUNT],filt1b,hdr_rva+2,1
	mov [CURRPOOLN],0
	mov [CURRPOOLTXT],0
ReadConstantPoolToBuffer:
	mov ebx,[CONTSTANSCOUNT]
	dec ebx
@startloop:
	inc [CURRPOOLN]
	inc [CURRPOOLTXT]
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	push ebx
	mov eax,[CURRPOOLTXT]
	call dw2a
	mov ebx,eax
	mov eax,[hCurrArray]
	mov [eax],ebx
	mov ebx,eax
	mov eax,[CURRPOOLN]
	dec eax
	stdcall pAddItem,[hPool2],ebx,eax,0
	add [hCurrArray],10h
	xor eax,eax
	pop ebx
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	rdu 1
	dec al
	jz @UTF
	dec al
	dec al
	jz @INTEGER
	dec al
	jz @FLOAT
	dec al
	jz @LONG
	dec al
	jz @DOUBLE
	dec al
	jz @CLASS
	dec al
	jz @STRING
	dec al
	jz @FIELD
	dec al
	jz @METHOD
	dec al
	jz @INTERFACE
	dec al
	jz @NAT
@CLASS:
	rdu 2
	stdcall pAddCPType,CPCLASS
	call pAddCP2
	jmp @endloop
@FIELD:
	stdcall pAddCPType,CPFIELD
	rdu 2
	mov [temp],eax
	rdu 2
	invoke wsprintf,[hCurrArray],filt4,[temp],eax
	add esp,10h
	mov eax,[CURRPOOLN]
	dec eax
	stdcall pSetItem,[hPool2],[hCurrArray],eax,2
	add [hCurrArray],30h
	jmp @endloop
@METHOD:
	stdcall pAddCPType,CPMETHOD

	rdu 2
	mov [temp],eax
	rdu 2

	invoke wsprintf,[hCurrArray],filt4,[temp],eax
	add esp,10h
	mov eax,[CURRPOOLN]
	dec eax
	stdcall pSetItem,[hPool2],[hCurrArray],eax,2
	add [hCurrArray],30h
	jmp @endloop
@INTERFACE:
	stdcall pAddCPType,CPINTERFACE

	rdu 2
	mov [temp],eax
	rdu 2

	invoke wsprintf,[hCurrArray],filt4,[temp],eax
	add esp,10h
	mov eax,[CURRPOOLN]
	dec eax
	stdcall pSetItem,[hPool2],[hCurrArray],eax,2
	add [hCurrArray],30h
	jmp @endloop
@STRING:
	rdu 2
	stdcall pAddCPType,CPSTRING
	call pAddCP2
	jmp @endloop
@INTEGER:
	stdcall pAddCPType,CPINTEGER
	rdu 4
	mov edx,[CURRPOOLN]
	dec edx
	stdcall pAddElement,[hPool2],eax,filt7,edx,2
	jmp @endloop
@FLOAT:
	stdcall pAddCPType,CPFLOAT
	rdu 4
	mov edx,[CURRPOOLN]
	dec edx
	stdcall pAddElement,[hPool2],eax,filt7,edx,2
	jmp @endloop
@LONG:
	inc [CURRPOOLTXT]
	stdcall pAddCPType,CPLONG
	rdu 4
	rdu 4
	inc [LONGDOUBLEN]
	dec ebx
	jmp @endloop
@DOUBLE:
	inc [CURRPOOLTXT]
	stdcall pAddCPType,CPDOUBLE
	rdu 4
	rdu 4
	inc [LONGDOUBLEN]
	dec ebx
	jmp @endloop
@NAT:
	stdcall pAddCPType,CPNAMETYPE

	rdu 2
	mov [temp],eax
	rdu 2
	invoke wsprintf,[hCurrArray],filt5,[temp],eax
	add esp,10h
	mov eax,[CURRPOOLN]
	dec eax
	stdcall pSetItem,[hPool2],[hCurrArray],eax,2
	add [hCurrArray],30h
	jmp @endloop
@UTF:
	stdcall pAddCPType,CPUTF
	rdu 2
	mov ecx,eax
	inc eax
	push eax
	stdcall pCopyMemory,esi,[hCurrArray],ecx
	add esi,ecx
	mov eax,[CURRPOOLN]
	dec eax
	stdcall pSetItem,[hPool2],[hCurrArray],eax,2
	pop eax
	shl eax,2
	add [hCurrArray],eax
@endloop:
	dec ebx
	jz @end
	xor eax,eax
	jmp @startloop
@end:
	mov [temp],esi
	ret

READ_ACCFLGS:

	mov ebx,[hCurrArray]
	rdu 2
	call dw2a
	mov [ebx],eax
	stdcall pAddItem,[hPool1],roAccFlg,hdr_rva+3,0
	stdcall pSetItem,[hPool1],ebx,hdr_rva+3,1
	add [hCurrArray],30h
	ret

READ_THISFLAGS:
	mov ebx,[hCurrArray]
	rdu 2
	call dw2a
	mov [ebx],eax
	stdcall pAddItem,[hPool1],roThisClass,hdr_rva+4,0
	stdcall pSetItem,[hPool1],ebx,hdr_rva+4,1
	add [hCurrArray],30h
	ret

READ_SUPERCLASS:
	mov ebx,[hCurrArray]
	rdu 2
	call dw2a
	mov [ebx],eax
	stdcall pAddItem,[hPool1],roSuperClass,hdr_rva+5,0
	stdcall pSetItem,[hPool1],ebx,hdr_rva+5,1
	add [hCurrArray],30h
	ret

READ_INTERFACES_COUNT:
	mov ebx,[hCurrArray]
	rdu 2
	mov ecx,eax
	call dw2a
	mov [ebx],eax
	stdcall pAddItem,[hPool1],roInterCount,hdr_rva+6,0
	stdcall pSetItem,[hPool1],ebx,hdr_rva+6,1
	add [hCurrArray],30h
	ret

READ_INTERFACES:
	mov [CURRPOOLN],0
	test ecx,ecx
@@:
	jz @F
	mov edx,[CURRPOOLN]
	mov eax,edx

	call dw2a
	mov ebx,eax
	mov eax,[hCurrArray]
	mov [eax],ebx
	mov ebx,eax
	stdcall pAddItem,[hPool3],ebx,edx,0
	add [hCurrArray],10h


	mov ebx,[hCurrArray]
	rdu 2
	call dw2a
	mov [ebx],eax
	stdcall pSetItem,[hPool3],ebx,edx,1
	add [hCurrArray],30h

	inc [CURRPOOLN]
	dec ecx
	jmp @B
@@:
	ret
READ_FIELDS_COUNT:
	mov ebx,[hCurrArray]
	rdu 2
	mov ecx,eax
	call dw2a
	mov [ebx],eax
	stdcall pAddItem,[hPool1],roFldCount,hdr_rva+7,0
	stdcall pSetItem,[hPool1],ebx,hdr_rva+7,1
	add [hCurrArray],10h
	ret

READ_FIELDS:
	mov [CURRPOOLN],0
@@:
	test ecx,ecx
	jz @F
     ;number
	mov eax,[CURRPOOLN]
	call dw2a
	mov ebx,eax
	mov eax,[hCurrArray]
	mov [eax],ebx
	mov ebx,eax
	mov edx,[CURRPOOLN]
	stdcall pAddItem,[hPool4],ebx,edx,0
	add [hCurrArray],20h
     ;acc flgs
	mov ebx,[hCurrArray]
	rdu 2
	call dw2a
	mov [ebx],eax
	stdcall pSetItem,[hPool4],ebx,edx,4
	add [hCurrArray],20h
     ;name index
	mov ebx,[hCurrArray]
	rdu 2
	mov [temp],eax
	call dw2a
	mov [ebx],eax
	stdcall pSetItem,[hPool4],ebx,edx,2
	add [hCurrArray],20h

	mov eax,[hCurrArray]
	mov [lvi.pszText],eax
	mov eax,[LONGDOUBLEN]
	test eax,eax
	jz  @1_fld
	stdcall fFindItem,[hPool2],[temp]
	stdcall fGetItem, [hPool2],eax,2
	jmp @2_fld
@1_fld:
	dec [temp]
	stdcall fGetItem, [hPool2],[temp],2
@2_fld:
	stdcall pSetItem, [hPool4],eax,edx,1
	add [hCurrArray],60h

     ;descr index
	mov ebx,[hCurrArray]
	rdu 2
	call dw2a
	mov [ebx],eax
	stdcall pSetItem,[hPool4],ebx,edx,3
	add [hCurrArray],20h
     ;attrs count
	mov ebx,[hCurrArray]
	rdu 2
	mov [tmp],ecx
	mov ecx,eax
	call dw2a
	mov [ebx],eax
	stdcall pSetItem,[hPool4],ebx,edx,5
	add [hCurrArray],20h
	and eax,0F0F0F0Fh
	test eax,eax
	jz @flds_end
     ;read_attributes

@rdfld_attr:
	rdu 2
	rdu 4
	add esi,eax
	loop @rdfld_attr
@flds_end:
	mov ecx,[tmp]
	inc [CURRPOOLN]
	dec ecx
	jmp @B

@@:
	 ret

READ_METHODS_COUNT:
	mov ebx,[hCurrArray]
	rdu 2
	mov ecx,eax
	call dw2a
	mov [ebx],eax
	stdcall pAddItem,[hPool1],roMethodCount,hdr_rva+8,0
	stdcall pSetItem,[hPool1],ebx,hdr_rva+8,1
	add [hCurrArray],10h
	ret

READ_METHODS:
	mov [CURRPOOLN],0
@@:
	test ecx,ecx
	jz @F
     ;number
	mov eax,[CURRPOOLN]
	call dw2a
	mov ebx,eax
	mov eax,[hCurrArray]
	mov [eax],ebx
	mov ebx,eax
	mov edx,[CURRPOOLN]
	stdcall pAddItem,[hPool5],ebx,edx,0
	add [hCurrArray],10h
     ;acc flgs
	mov eax,[hCurrArray]
	rdu 2
	call dw2a
	mov [ebx],eax
	stdcall pSetItem,[hPool5],ebx,edx,4
	add [hCurrArray],20h
     ;name index
	mov ebx,[hCurrArray]
	rdu 2
	mov [temp],eax
	call dw2a
	mov [ebx],eax
	stdcall pSetItem,[hPool5],ebx,edx,2
	add [hCurrArray],20h

	mov eax,[hCurrArray]
	mov [lvi.pszText],eax

	mov eax,[LONGDOUBLEN]
	test eax,eax
	jz   @@1_met
	stdcall fFindItem,[hPool2],[temp]
	stdcall fGetItem, [hPool2],eax,2
	jmp @@2_met
@@1_met:
	dec [temp]
	stdcall fGetItem, [hPool2],[temp],2
@@2_met:
	stdcall pSetItem, [hPool5],eax,edx,1
	add [hCurrArray],60h

     ;descr index
	mov ebx,[hCurrArray]
	rdu 2
	call dw2a
	mov [ebx],eax
	stdcall pSetItem,[hPool5],ebx,edx,3
	add [hCurrArray],20h
     ;attrs count
	mov ebx,[hCurrArray]
	rdu 2
	mov [tmp],ecx
	mov ecx,eax
	call dw2a
	mov [ebx],eax
	stdcall pSetItem,[hPool5],ebx,edx,5
	add [hCurrArray],20h
	and eax,0F0F0F0Fh
	test eax,eax
	jz @mets_end
     ;read_attributes
@rdmet_attr:
	rdu 2
	rdu 4
	add esi,eax
	loop @rdmet_attr

@mets_end:
	mov ecx,[tmp]
	inc [CURRPOOLN]
	dec ecx
	jmp @B

@@:
	ret

READ_ATTRIBUTES_COUNT:
	mov ebx,[hCurrArray]
	rdu 2
	mov ecx,eax
	call dw2a
	mov [ebx],eax
	stdcall pAddItem,[hPool1],roAttribCount,hdr_rva+9,0
	stdcall pSetItem,[hPool1],ebx,hdr_rva+9,1
	add [hCurrArray],10h
	ret
READ_ATTRIBUTES:
	mov [CURRPOOLN],0
@@:
	test ecx,ecx
	jz @F
       ;number
	mov eax,[CURRPOOLN]
	mov edx,eax
	call dw2a
	mov ebx,eax
	mov eax,[hCurrArray]
	mov [eax],ebx
	mov ebx,eax
	stdcall pAddItem,[hPool6],ebx,edx,0
	add [hCurrArray],20h
       ;name index
	mov ebx,[hCurrArray]
	rdu 2
	call dw2a
	mov [ebx],eax
	stdcall pSetItem,[hPool6],ebx,edx,1
	add [hCurrArray],20h
       ;length
	rdu 4
	mov ebx,eax
	inc eax

	stdcall pAddElement,[hPool6],eax,filt1b,edx,2

      ;  stdcall fAllocBuff,eax
      ;  stdcall pCopyMemory,esi,eax,ebx
      ;  stdcall pSetItem,[hPool5],[tempbuff2],edx,3
      ;  add [hCurrArray],30h

	add esi,ebx
@attrs_end:
	inc [CURRPOOLN]
	dec ecx
	jmp @B
@@:

	ret
