;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;             CREATE OBJECTS         ;
;    return pointer to data of file  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc fCreateMapsOfFiles
      invoke  CreateFile,f.fsName,GENERIC_READ ,FILE_SHARE_READ,ebx,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,ebx
      mov     [f.fsHandle],eax
      invoke  GetFileSize,eax,ebx
      mov     [f.fsSize],eax
      invoke  CreateFileMapping,[f.fsHandle],ebx,PAGE_READONLY,ebx,ebx,ebx
      mov     [f.fsMap],eax
      invoke  MapViewOfFile,eax,FILE_MAP_READ,ebx,ebx,ebx
      mov     [f.fsData],eax
      ret
endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;             DESTROY OBJECTS        ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc pDestroyMapsOfFiles uses eax
      invoke  UnmapViewOfFile,[f.fsData]
      invoke  CloseHandle,[f.fsMap]
      invoke  CloseHandle,[f.fsHandle]
      ret
endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;               Swap Pools           ;
;               ebx - pool           ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc pSwapPools uses eax ebx,pool
       invoke ShowWindow,[CurrentShow] ,SW_HIDE
       mov ebx,[pool]
       invoke ShowWindow,ebx,SW_SHOW
       mov [CurrentShow],ebx
       ret
endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       Add new column to 0          ;
; Add first coloumn to LV            ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc pAddColumn uses eax,pool,txt,cx
       mov eax,[txt]
       mov [lvc.pszText],eax
       mov eax,[cx]
       mov [lvc.cx],eax
       mov eax,[pool]
       invoke SendMessage,eax,LVM_INSERTCOLUMN,ebx,lvc
       ret
endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       Add new item                 ;
; Insert new item to LV              ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc pAddItem uses eax ecx edx, pool,txt,i,si
       mov eax,[txt]
       mov [lvi.pszText],eax
       mov eax,[i]
       mov [lvi.iItem],eax
       mov eax,[si]
       mov [lvi.iSubItem],eax
       mov eax,[pool]
       invoke SendMessage,eax,LVM_INSERTITEM,0,lvi
       ret
endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       Set item                     ;
; Set exist item                     ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc pSetItem uses eax ecx edx,pool,txt,i,si
       mov eax,[txt]
       mov [lvi.pszText],eax
       mov eax,[i]
       mov [lvi.iItem],eax
       mov eax,[si]
       mov [lvi.iSubItem],eax
       mov eax,[pool]
       invoke SendMessage,eax,LVM_SETITEM,0,lvi
       ret
endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       Get existing item            ;
; return - pointer to text           ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc fGetItem uses ecx edx,pool,i,si
       mov eax,[i]
       mov [lvi.iItem],eax
       mov eax,[si]
       mov [lvi.iSubItem],eax
       mov [lvi.cchTextMax],60h
       invoke SendMessage,[pool],LVM_GETITEM,0,lvi
       mov eax,[lvi.pszText]
       ret
endp


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       Get existing item            ;
; return - pointer to text           ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc fFindItem uses ecx edx,pool,numb
       mov ecx,[hCurrArray]
       mov [lvfi.psz],ecx
       mov eax,[numb]
       call dw2a
       mov [ecx],eax
       mov eax,[numb]
       sub eax,[LONGDOUBLEN]
       invoke SendMessage,[pool],LVM_FINDITEM,eax,lvfi
       add [hCurrArray],40h
       ret
endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     Add new element                ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc pAddElement uses eax ecx,pool,txt,flt,i,si
local  lpool:DWORD
local  ltxt:DWORD
       mov eax,[pool]
       mov [lpool],eax
       mov eax,[txt]
       mov [ltxt],eax
       mov eax,[hCurrArray]
       invoke wsprintf,eax,[flt],[ltxt]
       add esp,0Ch
       mov eax,[hCurrArray]
       stdcall pSetItem,[lpool],eax,[i],[si]
       add [hCurrArray],40h
       ret
endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;               Virtual               ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc pVirtualInit,harray
     invoke VirtualAlloc,0,1024*1024*1024,MEM_RESERVE,PAGE_READWRITE
     mov ebx,[harray]
     mov [ebx],eax
     ret
endp

proc pVirtualAlloc,harray,size
     mov eax,[size]
     invoke VirtualAlloc,[harray],eax,MEM_COMMIT,PAGE_READWRITE
     ret
endp

proc pVirtualFree,harray
     invoke VirtualFree,[harray],0,MEM_RELEASE

     ret
endp


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Convert LONG/DOUBLE(64b) to ANSI  ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc pLD2ANSI uses eax ecx edi esi,toLD,toBUFF,n
     mov esi,[toLD]
     mov edi,[toBUFF]
     mov ecx,[n]
     shr ecx,2
@@:
     xor eax,eax
     mov ax,[esi]
     add esi,2
     call dw2a
     bswap eax
     mov [edi],eax
     add edi,4
     dec ecx
     jecxz @F
     jmp @B
@@:
     mov eax,[toBUFF]
     ret
endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     Convert WORD to ANSI           ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc dw2a uses ecx ebx edx
      xor ebx,ebx
      xor ecx,ecx
      xor edx,edx
      mov cl,4
@start:
       shl eax,4
       rol al,4
       cmp al,09h
       jg @F
       or bl,30h
       jmp @enddw2a
@@:
       or bl,37h
@enddw2a:
       ror ebx,8
       mov dl,al
       ror eax,8
       ror edx,8
       loop @start
       lea eax,[edx+ebx]
       bswap eax
       ret
endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     Copy memory to buff            ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
proc pCopyMemory uses eax ecx esi edi,src,dest,numb
     mov ecx,[numb]
     mov esi,[src]
     mov edi,[dest]
     rep movsb
     ret
endp

proc pAddCP2 uses ebx eax
	call dw2a
	mov ebx,eax
	mov eax,[hCurrArray]
	mov [eax],ebx
	mov ebx,eax
	mov eax,[CURRPOOLN]
	dec eax
	stdcall pSetItem,[hPool2],ebx,eax,2
	add [hCurrArray],20h
	ret
endp


proc pAddCPType uses eax,cptype
	mov eax,[CURRPOOLN]
	dec eax
	stdcall pSetItem,[hPool2],[cptype],eax,1
	ret
endp

proc fParseUTF uses ecx edi esi,pBuff,pStr,iLen
     mov ecx,[iLen]
     mov edi,[pBuff]
     mov esi,[pStr]
@start_parse:
     xor eax,eax
     rdu 2


@@:




@end_loop_parse:


     ret
endp
